package com.franckbarbier.mediator.java;

interface Event_handler { // Inspiration from https://docs.oracle.com/javase/tutorial/uiswing/events/actionlistener.html

    void occur(java.util.EventObject event);
}

public class Mediator {

    // Possible extension is multiple event handlers:
    private static final java.util.Map<java.util.EventObject, Event_handler> _Communication = new java.util.HashMap<>();

    public static void Occur(java.util.EventObject event) {
        Event_handler callee = _Communication.get(event);
        if (callee != null) {
            callee.occur(event);
        }
    }

    public static void Subscribe(Communicator callee, java.util.EventObject event) {
//        _Communication.put(event, new Event_handler() {
//            @Override
//            public void occur(java.util.EventObject event) {
//                callee.handle(event);
//            }
//        });
        _Communication.put(event, (Event_handler) (java.util.EventObject event_) -> {
            callee.handle(event_);
        });
    }
}
